/* Copyright (c) 2009 Peter Troshin
 *  
 *  JAva Bioinformatics Analysis Web Services (JABAWS) @version: 1.0     
 * 
 *  This library is free software; you can redistribute it and/or modify it under the terms of the
 *  Apache License version 2 as published by the Apache Software Foundation
 * 
 *  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 *  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Apache 
 *  License for more details.
 * 
 *  A copy of the license is in apache_license.txt. It is also available here:
 * @see: http://www.apache.org/licenses/LICENSE-2.0.txt
 * 
 * Any republication or derived work distributed in source code form
 * must include this copyright and license notice.
 */
package compbio.engine.cluster.dundee;

import static org.testng.AssertJUnit.assertEquals;
import static org.testng.AssertJUnit.assertNotSame;
import static org.testng.AssertJUnit.assertTrue;

import java.net.UnknownServiceException;

import org.testng.annotations.Test;

import compbio.runner._NativeSpecHelper;

public class _QueueTester {
	@Test
	public void testQueue() {
		_NativeSpecHelper queueHelper = new _NativeSpecHelper(2000, 9);

		assertEquals(_Queue.PRIBIT64, queueHelper.getApproprieteQueue());
		queueHelper.setQueue("bigmem.q");
		assertEquals(_Queue.BIGMEM.toString(), queueHelper.getQueue());
		queueHelper.setQueue("devel.q");
		assertNotSame(_Queue.DEVEL, queueHelper.getApproprieteQueue());
		boolean hasfailed = false;
		try {
			queueHelper.getNativeSpec();
		} catch (UnknownServiceException e) {
			hasfailed = true;
		}
		assertTrue(hasfailed);

		queueHelper = new _NativeSpecHelper(14000, 9);
		assertEquals(_Queue.PRIBIT64, queueHelper.getApproprieteQueue());
		queueHelper.setRequiredMemory(14001);
		assertEquals(_Queue.BIGMEM, queueHelper.getApproprieteQueue());
		queueHelper.setRequiredMemory(32000);
		hasfailed = false;
		try {
			assertEquals(_Queue.BIGMEM, queueHelper.getApproprieteQueue());
		} catch (UnsupportedOperationException e) {
			hasfailed = true;
		}
		assertTrue(hasfailed);
		queueHelper = new _NativeSpecHelper(8000);
		assertEquals(_Queue.BIT64, queueHelper.getApproprieteQueue());
	}
}
